/*  Copyright (C) 2007-2009  Pako, Inc.
 *  Authors: Jeff Arnold, Anders Kaseorg, Tim Abbott
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License, version 2.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA
 *  02110-1301, USA.
 */

#ifdef PAKO_STANDALONE
#include "pako.h"
#else
#include <linux/pako.h>
#endif

extern struct pako_reloc pako_relocs[], pako_relocs_end[];
extern struct pako_section pako_sections[], pako_sections_end[];
extern struct pako_symbol pako_symbols[], pako_symbols_end[];
#ifdef PAKO_STANDALONE
extern struct pako_system_map pako_system_map[], pako_system_map_end[];
#endif /* PAKO_STANDALONE */

/* Defined in new_code_loader.c */
#define change PAKO_UNIQ(change)
extern struct pako_mod_change change;

static struct pako_code old_code = {
	.relocs = pako_relocs,
	.relocs_end = pako_relocs_end,
	.sections = pako_sections,
	.sections_end = pako_sections_end,
	.symbols = pako_symbols,
	.symbols_end = pako_symbols_end,
#ifdef PAKO_STANDALONE
	.system_map = pako_system_map,
	.system_map_end = pako_system_map_end,
#endif /* PAKO_STANDALONE */
};

static int init_old_code(void)
{
	change.old_code = old_code;
	return init_pako_mod_change(&change);
}

static void cleanup_old_code(void)
{
	cleanup_pako_mod_change(&change);
}

module_init(init_old_code);
module_exit(cleanup_old_code);

MODULE_AUTHOR("Pako, Inc.");
MODULE_DESCRIPTION("Pako rebootless update old code module");
#ifdef PAKO_VERSION
MODULE_VERSION(PAKO_VERSION);
#endif
MODULE_LICENSE("GPL v2");
